/**
 * @license
 * Copyright 2017 JBoss Inc
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
import { AbstractBaseComponent } from "./base-component";
import { ChangeDetectorRef, SimpleChanges } from "@angular/core";
import { OasDocument, Node } from "apicurio-data-models";
import { DocumentService } from "../../_services/document.service";
import { SelectionService } from "../../_services/selection.service";
export declare abstract class AbstractRowComponent<T extends Node, M> extends AbstractBaseComponent {
    item: T;
    protected _editing: boolean;
    protected _tab: string;
    protected _model: M;
    protected constructor(changeDetectorRef: ChangeDetectorRef, documentService: DocumentService, selectionService: SelectionService);
    protected onDocumentChange(): void;
    ngOnChanges(changes: SimpleChanges): void;
    protected abstract updateModel(): void;
    model(): M;
    document(): OasDocument;
    isEditing(): boolean;
    isEditingTab(tab: string): boolean;
    toggleTab(tab: string): void;
}
